---
title: Vary
slug: Web/HTTP/Headers/Vary
tags:
  - HTTP
  - Reference
  - Response
  - Response Header
  - header
---
<div>{{HTTPSidebar}}</div>

<p>The <strong><code>Vary</code></strong> HTTP response header determines how to match future request headers to decide whether a cached response can be used rather than requesting a fresh one from the origin server. It is used by the server to indicate which headers it used when selecting a representation of a resource in a <a href="/en-US/docs/Web/HTTP/Content_negotiation">content negotiation</a> algorithm.</p>

<p>The <code>Vary</code> header should be set on a {{HTTPStatus("304")}} <code>Not Modified</code> response exactly like it would have been set on an equivalent {{HTTPStatus("200")}} <code>OK</code> response.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Response header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Vary: *
Vary: &lt;header-name&gt;, &lt;header-name&gt;, ...
</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt>*</dt>
 <dd>Each request for a URL is supposed to be treated as a unique and uncacheable request. A better way to indicate this is to use {{HTTPHeader("Cache-Control")}}: <code>no-store</code>, which is clearer to read and also signals that the object shouldn't be stored ever.</dd>
 <dt>&lt;header-name&gt;</dt>
 <dd>A comma-separated list of header names to take into account when deciding whether or not a cached response can be used.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Dynamic_serving">Dynamic serving</h3>

<p>When using the <code>Vary: User-Agent</code> header, caching servers should consider the user agent when deciding whether to serve the page from cache. For example, if you are serving different content to mobile users, it can help you to avoid that a cache may mistakenly serve a desktop version of your site to your mobile users. It can help Google and other search engines to discover the mobile version of a page, and might also tell them that no <a href="https://en.wikipedia.org/wiki/Cloaking">Cloaking</a> is intended.</p>

<pre>Vary: User-Agent</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
  <tr>
   <td>{{RFC("7231", "Vary", "7.1.4")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Vary")}}</p>

<h2 id="Compatibility_notes">Compatibility notes</h2>

<ul>
 <li><a href="https://blogs.msdn.microsoft.com/ieinternals/2009/06/17/vary-with-care/">Vary with care – Vary header problems in IE6-9</a></li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.smashingmagazine.com/2017/11/understanding-vary-header/">Understanding The Vary Header - Smashing Magazine</a></li>
 <li><a href="https://www.fastly.com/blog/best-practices-for-using-the-vary-header">Best Practices for Using the Vary Header – fastly.com</a></li>
 <li><a href="https://developer.mozilla.org/docs/Web/HTTP/Content_negotiation">Content negotiation</a></li>
</ul>
